section .text

;%xdefine	nrep	(24*1024/16)
%xdefine	nrep	(12*1024/16)
%xdefine	nloop	1000

;=======================================================================

%push
global _vpgatherdd_4_tp
align 64
_vpgatherdd_4_tp:
	mov			ecx, nloop
	mov			eax, [esp+4]
	vzeroall
	vmovdqu		xmm0, [eax]
	vpcmpeqd	xmm7, xmm7, xmm7
.looplabel:

%rep nrep/4
	vmovdqa		xmm1, xmm7
	vpgatherdd	xmm2, [eax + xmm0], xmm1
	vmovdqa		xmm1, xmm7
	vpgatherdd	xmm3, [eax + xmm0], xmm1
	vmovdqa		xmm1, xmm7
	vpgatherdd	xmm4, [eax + xmm0], xmm1
	vmovdqa		xmm1, xmm7
	vpgatherdd	xmm5, [eax + xmm0], xmm1
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

%push
global _vpgatherdd_8_tp
align 64
_vpgatherdd_8_tp:
	mov			ecx, nloop
	mov			eax, [esp+4]
	vzeroall
	vmovdqu		ymm0, [eax]
	vpcmpeqd	ymm7, ymm7, ymm7
.looplabel:

%rep nrep/4
	vmovdqa		ymm1, ymm7
	vpgatherdd	ymm2, [eax + ymm0], ymm1
	vmovdqa		ymm1, ymm7
	vpgatherdd	ymm3, [eax + ymm0], ymm1
	vmovdqa		ymm1, ymm7
	vpgatherdd	ymm4, [eax + ymm0], ymm1
	vmovdqa		ymm1, ymm7
	vpgatherdd	ymm5, [eax + ymm0], ymm1
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

%push
global _vpgatherqq_2_tp
align 64
_vpgatherqq_2_tp:
	mov			ecx, nloop
	mov			eax, [esp+4]
	vzeroall
	vmovdqu		xmm0, [eax]
	vpcmpeqd	xmm7, xmm7, xmm7
.looplabel:

%rep nrep/4
	vmovdqa		xmm1, xmm7
	vpgatherqq	xmm2, [eax + xmm0], xmm1
	vmovdqa		xmm1, xmm7
	vpgatherqq	xmm3, [eax + xmm0], xmm1
	vmovdqa		xmm1, xmm7
	vpgatherqq	xmm4, [eax + xmm0], xmm1
	vmovdqa		xmm1, xmm7
	vpgatherqq	xmm5, [eax + xmm0], xmm1
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

%push
global _vpgatherqq_4_tp
align 64
_vpgatherqq_4_tp:
	mov			ecx, nloop
	mov			eax, [esp+4]
	vzeroall
	vmovdqu		ymm0, [eax]
	vpcmpeqd	ymm7, ymm7, ymm7
.looplabel:

%rep nrep/4
	vmovdqa		ymm1, ymm7
	vpgatherqq	ymm2, [eax + ymm0], ymm1
	vmovdqa		ymm1, ymm7
	vpgatherqq	ymm3, [eax + ymm0], ymm1
	vmovdqa		ymm1, ymm7
	vpgatherqq	ymm4, [eax + ymm0], ymm1
	vmovdqa		ymm1, ymm7
	vpgatherqq	ymm5, [eax + ymm0], ymm1
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop


%push
global _vpgatherdd_8_half_tp
align 64
_vpgatherdd_8_half_tp:
	mov			ecx, nloop
	mov			eax, [esp+4]
	vzeroall
	vmovdqu		ymm0, [eax]
	vpcmpeqd	ymm7, ymm7, ymm7
	vpsllq		ymm7, ymm7, 32
.looplabel:

%rep nrep/4
	vmovdqa		ymm1, ymm7
	vpgatherdd	ymm2, [eax + ymm0], ymm1
	vmovdqa		ymm1, ymm7
	vpgatherdd	ymm3, [eax + ymm0], ymm1
	vmovdqa		ymm1, ymm7
	vpgatherdd	ymm4, [eax + ymm0], ymm1
	vmovdqa		ymm1, ymm7
	vpgatherdd	ymm5, [eax + ymm0], ymm1
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;----------------------------------------------------------------------

%push
global _vpgatherdd_4_lt
align 64
_vpgatherdd_4_lt:
	mov			ecx, nloop
	mov			eax, [esp+4]
	vzeroall
	vmovdqu		xmm0, [eax]
	vpcmpeqd	xmm7, xmm7, xmm7
.looplabel:

%rep nrep
	vmovdqa		xmm1, xmm7
	vpgatherdd	xmm2, [eax + xmm0], xmm1
	vmovdqa		xmm0, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

%push
global _vpgatherdd_8_lt
align 64
_vpgatherdd_8_lt:
	mov			ecx, nloop
	mov			eax, [esp+4]
	vzeroall
	vmovdqu		ymm0, [eax]
	vpcmpeqd	ymm7, ymm7, ymm7
.looplabel:

%rep nrep
	vmovdqa		ymm1, ymm7
	vpgatherdd	ymm2, [eax + ymm0], ymm1
	vmovdqa		ymm0, ymm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

%push
global _vpgatherqq_2_lt
align 64
_vpgatherqq_2_lt:
	mov			ecx, nloop
	mov			eax, [esp+4]
	vzeroall
	vmovdqu		xmm0, [eax]
	vpcmpeqd	xmm7, xmm7, xmm7
.looplabel:

%rep nrep
	vmovdqa		xmm1, xmm7
	vpgatherqq	xmm2, [eax + xmm0], xmm1
	vmovdqa		xmm0, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

%push
global _vpgatherqq_4_lt
align 64
_vpgatherqq_4_lt:
	mov			ecx, nloop
	mov			eax, [esp+4]
	vzeroall
	vmovdqu		ymm0, [eax]
	vpcmpeqd	ymm7, ymm7, ymm7
.looplabel:

%rep nrep
	vmovdqa		ymm1, ymm7
	vpgatherqq	ymm2, [eax + ymm0], ymm1
	vmovdqa		ymm0, ymm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop


%push
global _vpgatherdd_8_half_lt
align 64
_vpgatherdd_8_half_lt:
	mov			ecx, nloop
	mov			eax, [esp+4]
	vzeroall
	vmovdqu		ymm0, [eax]
	vpcmpeqd	ymm7, ymm7, ymm7
	vpsllq		ymm7, ymm7, 32
.looplabel:

%rep nrep
	vmovdqa		ymm1, ymm7
	vpgatherdd	ymm2, [eax + ymm0], ymm1
	vmovdqa		ymm0, ymm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;----------------------------------------------------------------------

%push
global _insextdd_4_lt
align 64
_insextdd_4_lt:
	mov			ecx, nloop
	mov			eax, [esp+4]
	push		ebx
	vzeroall
	vmovdqu		xmm0, [eax]
.looplabel:

%rep nrep
	vpextrd		ebx, xmm0, 0
	mov			edx, [eax + ebx]
	vpinsrd		xmm2, edx, 0
	vpextrd		ebx, xmm0, 1
	mov			edx, [eax + ebx]
	vpinsrd		xmm2, edx, 1
	vpextrd		ebx, xmm0, 2
	mov			edx, [eax + ebx]
	vpinsrd		xmm2, edx, 2
	vpextrd		ebx, xmm0, 3
	mov			edx, [eax + ebx]
	vpinsrd		xmm2, edx, 3
	vmovdqa		xmm0, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	pop		ebx
	ret
%pop

%push
global _insextdd_8_lt
align 64
_insextdd_8_lt:
	mov			ecx, nloop
	mov			eax, [esp+4]
	push		ebx
	vzeroall
	vmovdqu		ymm0, [eax]
.looplabel:

%rep nrep
	vextracti128	xmm1, ymm0, 1

	vpextrd		ebx, xmm0, 0
	mov			edx, [eax + ebx]
	vpinsrd		xmm2, edx, 0
	vpextrd		ebx, xmm0, 1
	mov			edx, [eax + ebx]
	vpinsrd		xmm2, edx, 1
	vpextrd		ebx, xmm0, 2
	mov			edx, [eax + ebx]
	vpinsrd		xmm2, edx, 2
	vpextrd		ebx, xmm0, 3
	mov			edx, [eax + ebx]
	vpinsrd		xmm2, edx, 3

	vpextrd		ebx, xmm1, 0
	mov			edx, [eax + ebx]
	vpinsrd		xmm3, edx, 0
	vpextrd		ebx, xmm1, 1
	mov			edx, [eax + ebx]
	vpinsrd		xmm3, edx, 1
	vpextrd		ebx, xmm1, 2
	mov			edx, [eax + ebx]
	vpinsrd		xmm3, edx, 2
	vpextrd		ebx, xmm1, 3
	mov			edx, [eax + ebx]
	vpinsrd		xmm3, edx, 3

	vinserti128	ymm2, ymm2, xmm3, 1

	vmovdqa		xmm0, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	pop		ebx
	ret
%pop
